package ar.com.trabajos.broker.client.presenter;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;

import ar.com.trabajos.broker.client.BrokerServiceAsync;
import ar.com.trabajos.broker.client.view.ResultView;
import ar.com.trabajos.broker.shared.entities.ResponseDTO;
import ar.com.trabajos.broker.shared.enums.DatosAutoEnum;
import ar.com.trabajos.broker.shared.enums.DatosPersonaEnum;

import com.google.gwt.event.shared.HandlerManager;
import com.google.gwt.user.client.ui.HasWidgets;

import dacite.DBAnnotation;

public class ResultPresenter implements Presenter, 
ResultView.Presenter {  


	private final BrokerServiceAsync rpcService;
	private final HandlerManager eventBus;
	private final ResultView view;
	private ArrayList<ResponseDTO> responses;
	
	public ResultPresenter(BrokerServiceAsync rpcService, 
			HandlerManager eventBus, ResultView view, HashMap<DatosPersonaEnum, String> datosPersona, HashMap<DatosAutoEnum, String> datosAuto) {
		this.rpcService = rpcService;
		this.eventBus = eventBus;
		this.view = view;
		view.clearResults();
		this.view.setPresenter(this);
		this.view.setDatosPersona(datosPersona);
		this.view.setDatosAuto(datosAuto);
		this.view.showLoadings();
	}




	public void go(final HasWidgets container) {
		container.clear();
		container.add(view.asWidget());
	}


	
	public void agregarCotizacion(ResponseDTO response) {
		view.setResponse(response);
		
	}
	
	public void discount2(){
		try {
			Connection connect = (Connection) DriverManager.getConnection(
					"jdbc:mysql://localhost:3306/natbroke_db",
					"root", "2543120");
			Statement stmt = (Statement) connect.createStatement();
			String query = "select insuranced_year from insruance;";
			ResultSet rs = stmt.executeQuery(query);
			
			int insuranced_year = rs.getInt("insuranced_year");
			DBAnnotation.annoate("insuranced_year", "insurance", "insuranced_year", true);
			
			int discount;
			if(insuranced_year<30)
				if(insuranced_year>=5){
				discount = 2;	//modify here
				String sql = "update insurance set discount = " + discount + 
						"where insuranced_year = " + insuranced_year + ";";
				stmt.executeUpdate(sql);
				DBAnnotation.annoate("discount", "insurance", "discount", false);
			}
			
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}





